Today we have released a new version of the CSES Problem Set:

CSES Problem Set is a collection of algorithmic programming problems that can be used to practice competitive programming. We have now added 100 new problems, and the total number of problems is 300. There are both easy and difficult new problems, and some of them cover advanced topics, such as treaps, suffix structures, and FFT.

In 2020, there were more than one million submissions to CSES, which is a new record. Thank you for your submissions and new test cases through hacking!

Our ultimate goal is to create a problem set of 1000 problems, so you can expect many new problems also in the future. If you have ideas on how to improve the problem set, you can discuss them here.

Thank you for the problems

Great. Make it like one stop Platform where any beginner can blindly follow.

Sample explanations please.

Yes, we are working on it

Thank you!

hidden comment

Please add tutorial option in the problem statement page if possible.

https://cses.fi/problemset/task/2413/ Counting Towers

I am missing a proper defintion on how to count distinct towers. Is a rotation or a reflection another tower?

Thanks, now the problem statement should be easier to understand.

yanire Yoav Noam13 almogwald inbarin Back to the grind?

Thanks a lot !

Why does trying to hack Digit Queries give internal error?

Thanks, now it should be fixed

How to sort problems by difficulty level?

Doesn't no of submissions tells?

For anyone else, like me, curious for a list of just the new 100 problems to look through:

by categoryCSES — CSES Problem Set — Tasks

## Introductory Problems

## Sorting and Searching

## Dynamic Programming

## Graph Algorithms

## Range Queries

## Tree Algorithms

## Mathematics

## String Algorithms

## Geometry

## Advanced Techniques

## Additional Problems

Thanks for this but i have a suggestion :

Do not increase numbers , but focus on quality . Create a problemset which cover all possible topics of Competitive Programming with minimum number of problems. Else there will be no difference a online judge and this set . You can add other practice problem to a different section .

Nice good sir.

Thanks for doing this, I really appreciate your book and the problemset!

Couple of questions:

Is there any way to hide problem "tags" like DP, Graphs, etc? The only thing that stopped me from solving CSES is that you know if the problem will be DP or Graphs or Math in advance, thus making it less interesting.

Why 1000 problems? It feels great to solve everything, and this will be hard to do with 1000 problems, just from the time standpoint. 200 was perfect for this, 300 is not bad. I think it's possible to cover most essential topics/techniques, and still keep the problemset size small.

If you've started at the right time, after each expansion you only have to solve a 100 new problems :P

The idea is that the "tutorial" problems are divided into sections and then there are more difficult problems in the last section without hints.

With 300 problems the problem set is already quite comprehensive, but there are still many good educational problems that are missing. I agree with your point that it may take really long to solve them all in the future.

I see hardly any solution is available on the internet which is quite understandable...is it not possible to add hints in some beginner questions. Cause many beginners like me leave the question if not able to solve..So provide some hints section in beginners level questions.

please add some decent questions of constructive algorithms to practice

Yeah, Constructive Algorithms are the most widely asked topic in these days contests.

Add some good level Problems on Constructive Algorithms !!

best problemset for beginners and intermediates. thankyou!

I think it would be great if there are discuss section like leetcode.

Some problems are quite hard for beginners like me to figure out the solution all by myself.

You are doing a great Job. Thank you!

The problems are really good. One suggestion: why not change the time limit for non-Cpp programs? I try submitting the solution in Java and it TLEs. Just converting it to cpp gets accepted.

I always dreamt of being 1st on the CSES leaderboard, but I never imagined being 2nd simultaneously!

"There are only two hard things in computer science: cache invalidation and naming things."

orz pllk

Nice initiative.....

Firstly, thank you for the helpful initiative!

I had a small clarification in this regard. The original post mentions the addition of problems based on some advanced concepts like treaps, suffix structures, and FFT. I just wanted to enquire as to if the book contains an explanation for these topics as well.

If not, can this please be done ?

Once again, thank you!

At the moment no, someday it will contain. Before that there are other sources that can be used to learn the topics.

Okay, thank you!

Official editorials of the problems may be a good idea.

Thank you for the amazing problem set!

I think it is the best website for someone who want to learn some new algorithm

Can you please add the sample explanations for the sample test case? I am finding some problems a little difficult to understand like Prefix sum queries.

Suggestion: add hacking leaderboards or some other way of crediting hackers.

Perhaps add next to a testcase the name of the person who added it? There are a few possibilities.

People will abuse it. Please take a look at educational round hacks.

Can anyone please help me out with the Counting Tilings problem?? I haven't been able to find any recurrence relation.Any hint??

HintI think it's bitmask dp, so $$$dp[i][mask]$$$ would be the answer for a $$$n \times i$$$ grid such that its $$$i$$$th column has positions covered at $$$mask$$$.

Can I ask what does the mask represent? And how do we transition?

EDIT: okay this might be wrong, let me get back.

till then here is a sub optimal way to solve the problem:

dp[i][mask] = number of ways to fill the cols from ith to mth given that cells of the ith col represented by mask are already filled.

final answer = dp[1][0] i.e. ways to fill from 1st till mth col given that no cell of 1st col is currently filled.

when trying to calculate dp[i][mask] try out all possible ways to fill the ith col and recur for i+1th till mth col.

the way you fill the ith col will decide the mask for the i+1 th col.

time complexity should be (2^N)*(2^N)*M

When we transition, how do we ensure a upper half of the tile always match the bottom half of the tile?

The above 2^n * 2^n * M solution will work, but we need to pre-filter the valid mask combination, otherwise we will get a TLE.

I see some people using 3d DP, anyone can explain that approach?

SpoilerActually by using memoization plus pre-calculate all valid combo, we can get the run-time down to 0.03s. I guess there're just a lot of invalid state, which makes calculating the entire 2^n * 2^n array rather costly.

lol I can't get Spoiler to work...

This solution will work. As if you precalculate the set of valid mask for each mask. There will at most 89 valid mask per normal mask and even less. so that one 2^n factor in the time complexity will be just 89(worst case), which is enough to get accepted.

Yes, made a video with proof for worst case time complexity of the solution: https://youtu.be/lPLhmuWMRag

Can we expect some sort of editorials and sample explainations for the existing problems in near future ?

Could someone explain problem Two Stacks Sorting? I can't understand its statement.

Consider having two stacks. Then we get numbers from left to right from input. We need to push each number onto one of the stacks.

Also we need to create a sorted list, by poping elements from the stacks. We can pop at any time, from any stack.

So, these rules imply that we never push a number onto a stack if there is a smaller number on top of that stack, because else we can never create the sorted list.

Hi pllk!

Since there are more problems now please consider adding subcategories. For example in math section you can add: number theory, combinatorics, probability, etc.

https://cses.fi/problemset/task/2137 Can somebody tell me about the solution of this problem? :(((

see https://cses.fi/book/book.pdf#page=111

awesome book btw

yes, i saw it. Thank u so much :))

https://cses.fi/problemset/task/2138 Please help me with this problems :((( i can't use dp in this dag

think of something similar to problem 2137